#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

void send_channel_volume ( float myval, char* channel );
void show_volume ( GtkWidget* voldb, gdouble value );

void
on_mute_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("MUON");
		}
	else{
		/* If control reaches here, the toggle button is up */
		swrite("MUOFF");
		}
}




void
on_power_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("PWON");
		}
	else{
		/* If control reaches here, the toggle button is up */
		swrite("PWSTANDBY");
		}

}


gboolean
on_volume_button_release_event         (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	char *val= malloc(10);
	if (gtk_range_get_value(GTK_RANGE(widget)) < 10)
		sprintf (val,"MV0%-1.0f", gtk_range_get_value(GTK_RANGE(widget)));
	else
		sprintf (val,"MV%-2.0f", gtk_range_get_value(GTK_RANGE(widget)));
	swrite(val);

	free(val);

  return FALSE;
}





gboolean
on_window1_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	restoreline();
	exit(TRUE);
	return FALSE;
	
}





void
on_video_source_changed                (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	char val[15];
	sprintf (val,"SV%s", gtk_combo_box_get_active_text (GTK_COMBO_BOX (combobox)));
	swrite(val);
}


void
on_source_changed                      (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	char val[15];
	sprintf (val,"SI%s", gtk_combo_box_get_active_text (GTK_COMBO_BOX (combobox)));
	swrite(val);
}

void
on_record_source_changed               (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
char val[15];
	sprintf (val,"SR%s", gtk_combo_box_get_active_text (GTK_COMBO_BOX (combobox)));
	swrite(val);

}

void
on_pcm_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("SDPCM");
		}

}


void
on_dts_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("SDDTS");
		}

}


void
on_ana_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("SDANALOG");
		}

}


void
on_ext_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("SDEXT.IN-1");
		}

}



void
on_inputauto_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("SDAUTO");
		}


}




void
on_surround_mode_changed               (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
char val[15];
	sprintf (val,"MS%s", gtk_combo_box_get_active_text (GTK_COMBO_BOX (combobox)));
	swrite(val);

}


void
on_fm_toggled                          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("TMFM");
		}
}


void
on_am_toggled                          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("TMAM");
		}
}


void
on_up_clicked                          (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *preset = lookup_widget(GTK_WIDGET(button), "preset");
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (preset)))
		swrite("TPUP"); else swrite("TFUP");


}


void
on_down_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *preset = lookup_widget(GTK_WIDGET(button), "preset");
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (preset)))
		swrite("TPDOWN"); else swrite("TFDOWN");


}


void
on_tauto_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("TMAUTO");
		}
}


void
on_tmanual_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (togglebutton))){
		/* If control reaches here, the toggle button is down */
		swrite("TMMANUAL");
		}
}


void
on_window1_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
swrite("MU?");
swrite("PW?");
swrite("MV?");
swrite("SI?");
swrite("MS?");
swrite("SR?");
swrite("TP?");
swrite("TM?");
swrite("TF?");

}


void
on_channels_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *window1 = lookup_widget(GTK_WIDGET(button), "window1");
	if (gtk_object_get_data (GTK_OBJECT (window1), "window2") == NULL){
		GtkWidget *window2 = create_window2 ();
		gtk_widget_show (window2);
		gtk_object_set_data(GTK_OBJECT(window1),"window2",window2);
		gtk_object_set_data(GTK_OBJECT(window2),"window1",window1);
		swrite("CV?");
	}
}
	



gboolean
on_window2_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	GtkWidget *window2 = lookup_widget(GTK_WIDGET(widget), "window2");
	GtkWidget *window1 = gtk_object_get_data (GTK_OBJECT (window2), "window1");
	gtk_object_set_data(GTK_OBJECT(window1),"window2",NULL);

  return FALSE;
}






void
on_reload_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
swrite("MU?");
swrite("PW?");
swrite("MV?");
swrite("SI?");
swrite("MS?");
swrite("SR?");
swrite("TP?");
swrite("TM?");
swrite("TF?");

}




void send_channel_volume ( float myval, char* channel ) {
	char *val= malloc(15);

	if (myval < 10)
		sprintf (val,"CV%s 0%-1.0f",channel, myval);
	else
		sprintf (val,"CV%s %-2.0f", channel, myval);
	swrite(val);

	free(val);
}






gboolean
on_fl_button_release_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
send_channel_volume ( gtk_range_get_value(GTK_RANGE(widget)), "FL");
  return FALSE;
}



gboolean
on_fr_button_release_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
send_channel_volume ( gtk_range_get_value(GTK_RANGE(widget)), "FR");

  return FALSE;
}


gboolean
on_c_button_release_event              (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
send_channel_volume ( gtk_range_get_value(GTK_RANGE(widget)), "C");

  return FALSE;
}


gboolean
on_sw_button_release_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
send_channel_volume ( gtk_range_get_value(GTK_RANGE(widget)), "SW");

  return FALSE;
}


gboolean
on_sl_button_release_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
send_channel_volume ( gtk_range_get_value(GTK_RANGE(widget)), "SL");

  return FALSE;
}


gboolean
on_sr_button_release_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
send_channel_volume ( gtk_range_get_value(GTK_RANGE(widget)), "SR");

  return FALSE;
}


gboolean
on_sbl_button_release_event            (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
send_channel_volume ( gtk_range_get_value(GTK_RANGE(widget)), "SBL");

  return FALSE;
}


gboolean
on_sbr_button_release_event            (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
send_channel_volume ( gtk_range_get_value(GTK_RANGE(widget)), "SBR");

  return FALSE;
}


gboolean
on_sb_button_release_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
send_channel_volume ( gtk_range_get_value(GTK_RANGE(widget)), "SB");

  return FALSE;
}


void
on_cv_refresh_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
swrite("CV?");
}


void show_volume ( GtkWidget* voldb, gdouble value ) {
	gtk_label_set_markup (GTK_LABEL(voldb), g_strdup_printf( "<b> %-2.0f </b>", value ));
}



gchar*
on_fl_format_value                     (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	show_volume ( lookup_widget(GTK_WIDGET(scale), "fldb"), value);
	return "\r";

}


gchar*
on_fr_format_value                     (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	show_volume ( lookup_widget(GTK_WIDGET(scale), "frdb"), value);
	return "\r";

}


gchar*
on_c_format_value                      (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	show_volume ( lookup_widget(GTK_WIDGET(scale), "cdb"), value);
	return "\r";

}


gchar*
on_sw_format_value                     (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	show_volume ( lookup_widget(GTK_WIDGET(scale), "swdb"), value);
	return "\r";

}


gchar*
on_sl_format_value                     (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	show_volume ( lookup_widget(GTK_WIDGET(scale), "sldb"), value);
	return "\r";

}


gchar*
on_sr_format_value                     (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	show_volume ( lookup_widget(GTK_WIDGET(scale), "srdb"), value);
	return "\r";

}


gchar*
on_sbl_format_value                    (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	show_volume ( lookup_widget(GTK_WIDGET(scale), "sbldb"), value);
	return "\r";

}


gchar*
on_sbr_format_value                    (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	show_volume ( lookup_widget(GTK_WIDGET(scale), "sbrdb"), value);
	return "\r";

}


gchar*
on_sb_format_value                     (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	show_volume ( lookup_widget(GTK_WIDGET(scale), "sbdb"), value);
	return "\r";

}


gchar*
on_volume_format_value                 (GtkScale        *scale,
                                        gdouble          value,
                                        gpointer         user_data)
{
	gtk_label_set_markup (GTK_LABEL ( lookup_widget(GTK_WIDGET(scale), "voldb")), g_strdup_printf( "<span size='xx-large'>%-2.0f</span>", value-80 ));
	return "\r";

}

